Subject: RE: iSCSI:Request/Response Ordering

From: Charles Monia <[email-masked]>
Date: Mon, 1 Oct 2001 14:30:54 -0700

While Ed's note is correct in the main, I believe the behavior specified in
SAM is not the only determinant of ordering behavior.

Strictly speaking, the ordering guarantees should also be a function of the
device model. For example, the streaming device model may require that
simple commands from a single initiator be processed in the order received.
I don't know if this consideration is reflected in the device-dependent SCSI
specs.

Charles
> -----Original Message-----
> From: Edward A. Gardner [mailto:[email-masked]]
> Sent: Saturday, September 29, 2001 8:16 PM
> To: Sanjeev Bhagat (TRIPACE/Zoetermeer); 'IPS Reflector'; [email-masked]
> Subject: Re: iSCSI:Request/Response Ordering
> 
> 
> * From the T10 Reflector ([email-masked]), posted by:
> * "Edward A. Gardner" <[email-masked]>
> *
> The simple answer is that an initiator may not make any 
> assumptions about
> the order of requests to the same blocks (by itself or other 
> initiators)
> that may be outstanding at the same time.  If you care about 
> ordering, an
> initiator must wait until previous requests are complete 
> before issuing a
> request that references the same block(s).
> 
> This assumes that all commands are issued as simple tasks, 
> which is the most
> common situation today (one suspects the only situation).
> 
> People have suggested more complex schemes in the past, amounting to
> exporting some portion of the transfer dependency graph to 
> the target.  The
> ordered task attribute is one approach to this.  None have 
> proved practical
> in practice.
> 
> In practice, if a target receives references to the same 
> block from multiple
> initiators, it can perform the operations in whatever order it wishes.
> There is no "correct" order, all are equally valid.  (Again, 
> I'm assuming
> all are issued as simple tasks).
> 
> Edward A. Gardner               [email-masked]
> Ophidian Designs                719 593-8866 voice
> 1262 Hofstead Terrace           719 593-8989 fax
> Colorado Springs, CO  80907     719 210-7200 cell
> -----Original Message-----
> From: Sanjeev Bhagat (TRIPACE/Zoetermeer) 
> <[email-masked]>
> To: 'IPS Reflector' <[email-masked]>; [email-masked] <[email-masked]>
> Date: Saturday, September 29, 2001 7:03 PM
> Subject: iSCSI:Request/Response Ordering
> 
> 
> Hello All (T10, IPS),
> 
> The SAM-2 specifications makes no assumption about, or places any
> requirement on the ordering of requests or responses between 
> tasks or task
> management functions received from different SCSI initiator ports.
> 
> In this scenario how can a SCSI target make correctly handle 
> the read/write
> requests made on same blocks by different intiators at the same time.
> 
> Sanjeev
> 
> 
> 
> *
> * For T10 Reflector information, send a message with
> * 'info t10' (no quotes) in the message body to [email-masked]
>